#! /bin/bash

trap "echo '*** BUILD FAILED! ***' 1>&2" ERR
set -ex -o pipefail
umask 022
export PATH='/bin:/usr/bin:/usr/local/bin:~/diet-pc/tools'
export CFLAGS=${CFLAGS:--Os}
export CXXFLAGS=${CXXFLAGS:--Os}

rebuild () {
    tar xjf nbd-2.9.13.tar.bz2
    cd nbd-2.9.13
    ./configure --prefix=/usr --sysconfdir=/etc --enable-syslog
    make nbd_server_LDADD='-Wl,-Bstatic -lglib-2.0 -Wl,-Bdynamic -lpthread -lrt'
    strip -R .note -R .comment nbd-client
    mkdir -p ../nbd-client/sbin
    cp nbd-client ../nbd-client/sbin/
    cd ..
    rm -rf nbd-2.9.13
}

while read FN; do
    eval "[ -e $FN ] || rebuild"
done < MANIFEST

ARCH=`ipkg -V 0 print_architecture | tail -n 1 | cut -f2 -d' '`
for CTRLFILE in */CONTROL/control; do
    sed -i -e "s/__ARCH__/$ARCH/g" $CTRLFILE
    sudo ipkg-build -o root -g root `dirname $CTRLFILE`/..
done
